#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define A 0
#define C 1
#define G 2
#define T 3


void CreateRandom(char* string, int length);
void ModifyTraining(char* file, char* out);



int main(int argc, char *argv[]) {

  if (argc<3) {
    fprintf(stderr, "Usage: modify <input_file> <output_file>\n");
    exit(-1);
  }
  ModifyTraining(argv[1], argv[2]);

  exit(0);
}

void ModifyTraining(char* file, char* out) {
  FILE *fdin;
  FILE *fdout;
  char* sequence;
  char* rand1;
  char* rand2;
  int length;

  sequence = (char *) malloc(sizeof(char)*1000);
  rand1 = (char *) malloc(sizeof(char)*1000);
  rand2 = (char *) malloc(sizeof(char)*1000);

  if ((fdin = fopen(file,"r")) < 0) {
      fprintf(stderr, "ERROR: Opening training file %s for modifying.\n",file);
      exit(-1);
  }
  if ((fdout = fopen(out, "w")) < 0) {
      fprintf(stderr, "ERROR: Opening file %s for modifying.\n", out);
      exit(-1);
  }
  while (fgets(sequence, 1000, fdin) != NULL) {
    if ((sequence[0]!='>')&&(strlen(sequence)>10)) { 
      sequence[strlen(sequence)-1] = '\0';
      CreateRandom(rand1, 50);
      CreateRandom(rand2, 50); 
      if (strlen(sequence)>1) {
	fprintf(fdout, "%s%s%s\n", rand1, sequence, rand2);
      }
    }
  }
  fclose(fdin);
  fclose(fdout);
}


void CreateRandom(char* string, int length) {
  int i,a;

  for (i=0; i<length; i++) {
    
    a = 1+(int) (6.0*rand()/(RAND_MAX+1.0));
    switch (a) {
      case 1 :
	string[i] = 'A';
	break;
      case 2 :
	string[i] = 'C';
	break;      
      case 3 :
	string[i] = 'G';
	break;
      case 4 :
	string[i] = 'T';
	break; 
      case 5 :
	string[i] = 'A';
	break;
      case 6 :
	string[i] = 'T';
	break;
    }
  }
}
